\usepackage{tikz}
\usetikzlibrary{positioning}
\usetikzlibrary{arrows}
\usetikzlibrary{fit}
\usetikzlibrary{petri}
\usetikzlibrary{decorations.markings}
\usetikzlibrary{decorations.pathmorphing}
\usetikzlibrary{fit}
\usetikzlibrary{automata}
\usetikzlibrary{shapes}
\usetikzlibrary{shadows}
\usetikzlibrary{calc}

\tikzset{
blueshading/.style={shade, top color=white, bottom color=kit-blue30, draw=kit-blue100, thick},
greyshading/.style={shade, top color=white, bottom color=black!30, draw=black!50, thick},
greenshading/.style={shade, top color=white, bottom color=kit-green30, draw=kit-green100, thick},
roundbox/.style={rectangle, rounded corners=.5ex}, 
seffaction/.style={rectangle split, rectangle split parts=2, rectangle split part align={center}, text centered, rounded corners},
pcmball/.style={shade, ball color=kit-blue100,circle,fill},
startaction/.style={pcmball,minimum size=1ex},
stopaction/.style={startaction,draw=black,double},
}

\tikzstyle{pcm} = [baseline=-.2ex]

\tikzoption{text badly
raggedleft}[]{\def\tikz@text@action{\raggedleft\relax}}
\tikzoption{text raggedleft}[]%
{\def\tikz@text@action{\raggedleft\rightskip\z@ plus2em
\spaceskip.3333em \xspaceskip.5em\relax}}

\pgfdeclarelayer{l1}
\pgfdeclarelayer{l2}
\pgfdeclarelayer{l3}
\pgfdeclarelayer{l4}
\pgfdeclarelayer{l5}
\pgfsetlayers{main,l1,l2,l3,l4,l5}

% Internal Action

\newcommand{\pcmintaction}[2][]{
	\node[pcmball, minimum size=.7ex, text width=0ex, #1] (#2) {};
	\draw[thick] (#2.north) -- ([yshift=.5ex]#2.north);
	\draw[thick] (#2.south) -- ([yshift=-.5ex]#2.south);
}

\newcommand{\pcmextaction}[2][]{
	\node[pcmball, minimum size=.7ex, text width=0ex, #1] (#2) {};
	\draw[thick,<-] (#2.north) -- ([yshift=1ex]#2.north);
	\draw[thick,->] (#2.south) -- ([yshift=-.8ex]#2.south);
	\draw[ultra thick,->,color=red!70!black] (#2.east) -- ([xshift=1ex]#2.east);
}


\newcommand{\pcmloopaction}[2][]{
	\node[pcmball, minimum size=.7ex, text width=0ex, #1] (#2) {} 
	edge [->, in=30, out=90, looseness=1, distance=2ex, thick] node {} (#2);
}

\newcommand{\pcmiterator}[2][]{
\begin{scope}[decoration={
	markings, mark=at position .5 with {\arrow[red, line width=.2ex]{>}}}, #1]
	\node[matrix,draw=black!75, row sep=.3ex, inner sep=.3ex]	(#2) {
	\draw[red,thick] (0,0) -- (.7ex,0);\\
	\draw[red,thick] (0,0) -- (.7ex,0);\\
	\draw[red,thick] (0,0) -- (.7ex,0);\\ };
	\draw [thick,black!75,postaction=decorate] 
	(#2.south) .. controls (0,-1.5ex) and (1.4ex,-1.5ex) .. 
	(1.4ex,0) .. controls (1.4ex,1.5ex) and (0,1.5ex) .. (#2.north);
\end{scope}
}

\newcommand{\pcmbranch}[2][]{
	{\pgfsetcornersarced{\pgfpointorigin}
	\scriptsize
	\node[diamond, shade, ball color=kit-blue100, inner sep=.1ex, text width=1.2ex, #1] (#2) {\color{white}\scriptsize\textbf?};
	\draw[thick] (#2.north) -- ([yshift=.8ex]#2.north);
	\draw[thick] (#2.south west) -- ([xshift=-.7ex,yshift=-.7ex]#2.south west);
	\draw[thick] (#2.south east) -- ([xshift=.7ex, yshift=-.7ex]#2.south east);
	}
}

\newcommand{\pcmfork}{
\begin{scope}[very thick,black!75]
	\draw (0,0) -- (0,.4em) -- (1em,.4em) -- (1em,0em);
	\draw (.33em,.4em) -- (.33em,0em);
	\draw (.66em,.4em) -- (.66em,0em);
	\draw (.5em,1em) -- (.5em,.4em);
	\draw (.2em,.75em) -- (.5em,.45em) -- (.8em,.75em);
\end{scope}
}

\newcommand{\pcmnote}{
	{\pgfsetcornersarced{\pgfpointorigin}
	\path[draw, black!75, thick, shade, top color=white, bottom color=yellow] (0,0) -- (2ex,0) -- (2ex,1ex) -- (1.5ex,1.5ex) -- (0,1.5ex) -- cycle;
	\draw[black!75, thick] (2ex,1ex) -- (1.5ex,1ex) -- (1.5ex,1.5ex);
	}
}

\newcommand{\pcmstart}[2][]{
	\node[startaction, text width=0cm, #1] (#2) {};
}

\newcommand{\pcmstop}[2][]{
	\node[stopaction, text width=0cm, #1] (#2) {};
}

\newcommand{\pcmsetvar}[2][]{
	\node[rectangle,draw=gray,ultra thick,dashed,#1] (#2) {\$x};
}

\newcommand{\pcmacq}{
\begin{scope}[every token/.style={color=kit-blue100,minimum size=.2ex}]
	\node[place, minimum size=1em,shade,
		bottom color=kit-blue30,top color=white,shading angle=30] {}
		[children are tokens, token distance=.4ex]
		child {node [token] {}}
		child {node [token] {}}
		child {node (inlier) [token] {}}
		child {node [token] {}}
		child {node [token] {}}
		child {node [token] {}}
		child {node [token] {}};
	\node[token] (outlier) at (.6em,.6em) {};
	\draw[->, red, very thick] (inlier) -- (outlier);
\end{scope}
}

\newcommand{\pcmrel}{
\begin{scope}[every token/.style={color=kit-blue100,minimum size=.2ex}]
	\node[place, minimum size=1em,shade,
		bottom color=kit-blue30,top color=white,shading angle=30] {}
		[children are tokens, token distance=.4ex]
		child {node [token] {}}
		child {node [token] {}}
		child {node (inlier) [token] {}}
		child {node [token] {}}
		child {node [token] {}}
		child {node [token] {}}
		child {node [token] {}};
	\node[token] (outlier) at (.6em,.6em) {};
	\draw[<-, red, very thick] (inlier) -- (outlier);
\end{scope}
}

\newcommand{\pcmdice}{
	\tikzset{point/.style={circle,fill=black,minimum size=.4ex,inner sep=0pt}}
\begin{scope}[every node/.append style={yslant=-0.5},yslant=-0.5]
	\shade[right color=white, left color=kit-blue30, draw=black, 
		rounded corners=.1ex] (0,0) rectangle +(1em,1em);
	\node [point] 	at (.25em,.25em) {};
	\node [point] 	at (.25em,.75em) {};
	\node [point] 	at (.5em,.5em) {};
	\node [point] 	at (.75em,.25em) {};
	\node [point] 	at (.75em,.75em) {};
\end{scope}

\begin{scope}[every node/.append style={yslant=0.5},yslant=0.5]
	\shade[left color=white, right color=kit-blue30, draw=black, 
		rounded corners=.1ex] (1em,-1em) rectangle +(1em,1em);
	\node [point] 	at (1.25em,-.25em) {};
	\node [point] 	at (1.25em,-.75em) {};
	\node [point] 	at (1.75em,-.25em) {};
	\node [point] 	at (1.75em,-.75em) {};
\end{scope}


\begin{scope}[every node/.append style={
    yslant=0.5,xslant=-1},yslant=0.5,xslant=-1
  ]
  \shade[bottom color=white, top color=kit-blue30, draw=black, 
		rounded corners=.1ex] (2em,1em) rectangle +(-1em,-1em);
	\node [point] 	at (1.25em,.25em) {};
	\node [point] 	at (1.25em,.75em) {};
	\node [point] 	at (1.5em,.25em) {};
	\node [point] 	at (1.5em,.75em) {};
	\node [point] 	at (1.75em,.25em) {};
	\node [point] 	at (1.75em,.75em) {};
\end{scope}

	\draw[thick, color=black] (.5em,-.25em) -- +(-.7ex,-.7ex);
	\draw[thick, color=black] (1.5em,-.25em) -- +(.7ex,-.7ex);

}

\newcommand{\pcmcertsign}{
\begin{scope}[rotate=30]
\node [draw, red, thick, circle, rotate=30] (certified) at (0,0) {\scriptsize CERTIFIED};
\draw [red, thick] (.67,.2) arc (16.6:163.4:7mm) -- cycle;
\draw [red, thick] (-.67,-.2) arc (196.6:343.4:7mm) -- cycle;
\end{scope}
}
